/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c                                                */
/*  DATE        :                                                      */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "stdlib.h"
#include "iodefine.h"

unsigned char csi_send_end;

#define  CS0_ON    P1_bit.no4 = 0  // CS Low
#define  CS0_OFF   P1_bit.no4 = 1  // CS High

void CSI_Master_Transmit( unsigned char cData );
void delay_ms(int ms);
void delay_us(register int us);
void NJU6060_Init(void);
void NJU6060_RGB_Write ( unsigned char red, unsigned char green, unsigned char blue );
void main(void);

extern void HardwareSetup(void);
extern void CSI00Start(void);
extern void CSI00Send(unsigned char *tx_buf,unsigned char tx_num);

void main(void)
{
  unsigned char i;
  unsigned char red,green,blue;
  HardwareSetup();
  CSI00Start();
  NJU6060_Init();
  for( i=0 ; i<32 ; i++ )
  {
    NJU6060_RGB_Write( i,0,0);         // RGBݒ
    delay_ms(200);                     // 200ms wait
    P14 ^= 0x40;                       // P146]
  }
  delay_ms(2000);                      // 2s wait
  for( i=0 ; i<32 ; i++ )
  {
    NJU6060_RGB_Write( 0,i,0);         // RGBݒ
    delay_ms(200);                     // 200ms wait
    P14 ^= 0x40;                       // P146]
  }
  delay_ms(2000);                      // 2s wait
  for( i=0 ; i<32 ; i++ )
  {
    NJU6060_RGB_Write( 0,0,i);         // RGBݒ
    delay_ms(200);                     // 200ms wait
    P14 ^= 0x40;                       // P146]
  }
  delay_ms(2000);                      // 2s wait
  while (1U)
  {
    red   = rand( ) % 32;              // ԗ擾
    green = rand( ) % 32;              // Η擾
    blue  = rand( ) % 32;              // 擾

    NJU6060_RGB_Write( red, green, blue );  // RGBݒ
    delay_ms(500);                     // 500ms wait
    P14 ^= 0x40;                       // P146]
  }

}
void NJU6060_Init ( void )
{
  // NJU606Zbgo
  P1_bit.no7 = 0;                      // ZbgLow
  delay_us(100);                       // 100us wait
  P1_bit.no7 = 1;                      // ZbgHigh
  delay_us(100);                       // 100us wait
  // LED1-3IAOSCIAPWM=OSC/2/32
  CS0_ON;                              // CS Low
  CSI_Master_Transmit(0x6f);           // PWMgݒ
  CS0_OFF;                             // CS High
  
  CS0_ON;                              // CS Low
  CSI_Master_Transmit(0x81);           // PWM Phase=4-step
  CS0_OFF;                             // CS High
  
  CS0_ON;                              // CS Low
  CSI_Master_Transmit(0xa2);           // PWM Phase=8-step
  CS0_OFF;                             // CS High
  
  CS0_ON;                              // CS Low
  CSI_Master_Transmit(0xc3);           // PWM Phase=16-step
  CS0_OFF;                             // CS High
  
}
void NJU6060_RGB_Write ( unsigned char red, unsigned char green, unsigned char blue )
{
  red   = 0x1f & red;
  green = 0x1f & green;
  blue  = 0x1f & blue;
  
  CS0_ON;                              // CS Low
  CSI_Master_Transmit(0x00|red);       // Ԑݒ
  CS0_OFF;                             // CS High
  
  CS0_ON;                              // CS Low
  CSI_Master_Transmit(0x20|green);     // ΐݒ
  CS0_OFF;                             // CS High

  CS0_ON;                              // CS Low
  CSI_Master_Transmit(0x40|blue);      // ݒ
  CS0_OFF;                             // CS High
}
void CSI_Master_Transmit( unsigned char cData )
{
  CSI00Send(&cData,1);                 // M
  while( csi_send_end == 0 );          // M҂
  csi_send_end = 0;                    // MtONA
}
void delay_ms(int ms)
{
  volatile int i,j;
  for(i=0;i<ms;i++)
  {
    for(j=0;j<2963;j++)
    {

    }
  }
}
void delay_us(register int us)
{
  us<<=1;
  us-=8;
  while(us)
  {
    us--;
  }
}
