/***********************************************************************/
/*                                                                     */
/*  FILE        :hardware_setup.c                                      */
/*  DATE        :                                                      */
/*  DESCRIPTION :Hardware setup Program                                */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"
#include "macrodriver.h"

#define IIC00_WAITTIME      (160U)             // change the waiting time according to the system

volatile uint8_t   g_iic00_master_status_flag; // iic00 start flag
volatile uint8_t * gp_iic00_tx_address;        // iic00 send data pointer
volatile uint16_t  g_iic00_tx_count;           // iic00 send data size
volatile uint8_t * gp_iic00_rx_address;        // iic00 receive data pointer
volatile uint16_t  g_iic00_rx_count;           // iic00 receive data size
volatile uint16_t  g_iic00_rx_length;          // iic00 receive data length

void HardwareSetup(void);
void IIC00_Create(void);
void IIC00_Stop(void);
void IIC00_StartCondition(void);
void IIC00_StopCondition(void);

void HardwareSetup(void)
{
  IIC00_Create();                      // IIC00
  EI();                                // 荞݋
} 
void IIC00_Create(void)
{
  POM1 |= 0x03;                        // NchI[vhCo
  SAU0EN = 1;                          // VAACNbN
  NOP();
  NOP();
  NOP();
  NOP();
  SPS0L = 0B00000000;                  // 32MHzI
  SMR00 = 0x0024;                      // CK00I,ȈI2C[h,]荞
  SCR00 = 0x0017;                      // f[^8rbg
  SDR00 = 0x4E00;                      // 32MHz/80=400kHz
  SO0 = 0x0101;                        // NbNƃf[^Higho
  P1 |= 0x03;
  PM1 &= ~0x03;                        // NbNƃf[^|[gHigho
}
void IIC00_MasterSend(unsigned char addr,unsigned char *buf,unsigned char len )
{
  g_iic00_master_status_flag = 0;      // Xe[^XNA
  addr &= 0xFE;                        // MZbg
  g_iic00_master_status_flag = 1;      // Xe[^X M[hݒ
  SCR00 &= ~0xC000;                    // MNA
  SCR00 |= 0x8000;                     // M̂ݍs
  g_iic00_tx_count =len;               // MoCgۑ
  gp_iic00_tx_address = buf;           // MAhXۑ
  IIC00_StartCondition();              // X^[gRfBV
  IICIF00 = 0;                         // IIC00荞ݗvNA
  IICMK00 = 0;                         // IIC00荞݃}XNNA
  SIO00 = addr;                        // X[uAhXݒ
}
void IIC00_MasterReceive(unsigned char addr,unsigned char *buf,unsigned char len )
{
  g_iic00_master_status_flag = 0;      // Xe[^XNA
  addr |= 0x01;                        // MZbg
  g_iic00_master_status_flag = 2;      // Xe[^X M[hݒ
  SCR00 &= ~0xC000;                    // MNA
  SCR00 |= 0x8000;                     // M̂ݍs
  g_iic00_rx_length = len;             // MoCgۑ
  g_iic00_rx_count =0;                 // MJE^NA
  gp_iic00_rx_address = buf;           // MAhXۑ
  IIC00_StartCondition();              // X^[gRfBV
  IICIF00 = 0;                         // IIC00荞ݗvNA
  IICMK00 = 0;                         // IIC00荞݃}XNNA
  SIO00 = addr;                        // X[uAhXݒ
}
void IIC00_Stop(void)
{
  IICMK00 = 1;                         // IIC00}XNZbg
  ST0 |= 0x0001;                       // IIC00ʐM~
  IICIF00 = 0;                         // IIC00荞ݗvNA
}
void IIC00_StartCondition(void)
{
  volatile unsigned char w_count;
  
  SO0 &= ~0x0001;                      // f[^Lowo
  for (w_count = 0U; w_count <= IIC00_WAITTIME; w_count++)
  {
    NOP();
  }
  SO0 &= ~0x0100;                      // NbNLowo
  SOE0 |= 0x0001;                      // VAʐMo͋
  SS0 |= 0x0001;                       // ʐMҋ@ԃZbg
}
void IIC00_StopCondition(void)
{
  volatile unsigned char w_count;

  ST0 |= 0x0001;                       // IIC00ʐM~
  SOE0 &= ~0x0001;                     // VAʐMo͋֎~
  SO0 &= ~0x0001;                      // f[^Lowo
  SO0 |= 0x0100;                       // NbNHigho
  for (w_count = 0U; w_count <= IIC00_WAITTIME; w_count++)
  {
    NOP();
  }
  SO0 |= 0x0001;                       // f[^Higho
}