/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c                                                */
/*  DATE        :                                                      */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/

// MCP23017
#define MCP23017_BASE_ADDRESS  0x40

#define MCP23017_IODIRA    0x00
#define MCP23017_IODIRB    0x01
#define MCP23017_GPIOA     0x12
#define MCP23017_GPIOB     0x13

#define SLAVE_ADDR         0B01000000  // slave address

unsigned char iic_send_end;            // IICM
unsigned char iic_read_end;            // IICM

void main(void);
void init_mcp23017(unsigned char dirA,unsigned char dirB);
void IIC_send(unsigned char *buf, unsigned char len);
void IIC_read(unsigned char *buf, unsigned char len);

extern void HardwareSetup(void);
extern void IIC00_MasterSend(unsigned char addr,unsigned char *buf,unsigned char len );
extern void IIC00_MasterReceive(unsigned char addr,unsigned char *buf,unsigned char len );

void main(void)
{
  unsigned char iic_buf[2];
  HardwareSetup();
  init_mcp23017(0x00,0xFF);            // A:LEDo,BL:[
  while (1U)
  {
    iic_buf[0] = MCP23017_GPIOB;
    IIC_send(iic_buf,1);               // L[AhX
    IIC_read(&iic_buf[1],1);           // L[ǂݍ
    iic_buf[0] = MCP23017_GPIOA;
    IIC_send(iic_buf,2);               // LED
  }
}
void init_mcp23017(unsigned char dirA,unsigned char dirB)
{
  unsigned char tx_buf[2];
  // IODIRA
  tx_buf[0] = MCP23017_IODIRA;
  tx_buf[1] = dirA;
  IIC_send(tx_buf,2);                  // GPIOA̓o͐ݒ
  // IODIRB
  tx_buf[0] = MCP23017_IODIRB;
  tx_buf[1] = dirB;
  IIC_send(tx_buf,2);                  // GPIOB̓o͐ݒ
}
void IIC_send(unsigned char *buf, unsigned char len)
{
  IIC00_MasterSend(SLAVE_ADDR,buf,len);  // M
  while( iic_send_end == 0 );          // M҂
  iic_send_end = 0;                    // MNA
}
void IIC_read(unsigned char *buf, unsigned char len)
{
  IIC00_MasterReceive(SLAVE_ADDR,buf,len);  // M
  while( iic_read_end == 0 );          // M҂
  iic_read_end = 0;                    // MNA
}
