/***********************************************************************/
/*                                                                     */
/*  FILE        :hardware_setup.c                                      */
/*  DATE        :                                                      */
/*  DESCRIPTION :Hardware setup Program                                */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"
#include "macrodriver.h"

void HardwareSetup(void);
void UART1Init(void);
void UART2Init(void);
void InterruptInit(void);

void HardwareSetup(void)
{
  UART1Init();                         // UART1
  UART2Init();                         // UART2
  InterruptInit();                     // 荞ݏ
}

void UART1Init(void)
{
  SAU0EN=1;                            // VAACONbN
  SPS0L=0B00000100;                    // 32MHz/24=2MHz
  SMR02=0x0022;                        // UART[h,]荞
  SCR02=0x8097;                        // M̂,LSBt@[Xg,1STOP bit,f[^8rbg
  SDR02=0xCE00;                        // 2MHz/(CE/2+1)/2=9615Hz
  SMR03=0x0122;                        // ]Ď擾,UART[h,]荞
  SCR03=0x4097;                        // M̂,LSBt@[Xg,1STOP bit,f[^8rbg
  SDR03=0xCE00;                        // 2MHz/(CE/2+1)/2=9615Hz
  SOE0L_bit.no2=1;                     // `lQVAʐMɂo͋
  NFEN0_bit.no2=1;                     // RxD1̃mCYtB^ON
  P0=0B00000001;                       // M|[gHigh
  PM0=0B00000010;                      // M|[ǵAM|[go
}

void UART2Init(void)
{
  SAU1EN=1;                            // VAACPNbN
  SPS1L=0B00000100;                    // 32MHz/24=2MHz
  SMR10=0x0022;                        // UART[h,]荞
  SCR10=0x8097;                        // M̂,LSBt@[Xg,1STOP bit,f[^8rbg
  SDR10=0xCE00;                        // 2MHz/(CE/2+1)/2=9615Hz
  SMR11=0x0122;                        // ]Ď擾,UART[h,]荞
  SCR11=0x4097;                        // M̂,LSBt@[Xg,1STOP bit,f[^8rbg
  SDR11=0xCE00;                        // 2MHz/(CE/2+1)/2=9615Hz
  SOE1L_bit.no0=1;                     // `lOVAʐMɂo͋
  NFEN0_bit.no4=1;                     // RxD2̃mCYtB^ON
  P1=0B00001000;                       // M|[gHigh
  PM1=0B00010000;                      // M|[ǵAM|[go
}

void InterruptInit(void)
{
  SRMK1=0;                             // UART1M}XNNA
  STMK2=0;                             // UART2M}XNNA
  EI();                                // 荞݋
}
